const path = require("path");

module.exports = {
  entry: {
    SocketClient: "./src/client/SocketContext.tsx",
    SocketServer: "./src/server/SocketServer.ts",
  },
  externals: {
    react: "react",
    "react-dom": "react-dom",
  },
  mode: "production",
  module: {
    rules: [
      {
        exclude: /node_modules/,
        loader: "ts-loader",
        test: /\.tsx?$/,
      },
      {
        test: /\.(sa|sc|c)ss$/i,
        use: ["style-loader", "css-loader", "postcss-loader"],
      },
    ],
  },
  output: {
    filename: "[name].js",
    globalObject: "this",
    library: "react-node-socket-chat",
    libraryTarget: "umd",
    path: path.resolve(__dirname, "dist"),
  },
  resolve: {
    alias: {
      react: path.resolve(path.join(__dirname, "./node_modules/react")),
      "react-dom": path.resolve(
        path.join(__dirname, "./node_modules/react-dom")
      ),
    },
    extensions: [".tsx", ".ts", ".jsx", ".js"],
    // fallback: {
    //   url: false,
    //   fs: false,
    //   tls: false,
    //   net: false,
    //   path: false,
    //   zlib: false,
    //   http: false,
    //   https: false,
    //   stream: false,
    //   crypto: false,
    //   querystring: false,
    //   timers: false,
    //   buffer: false,
    //   path: false,
    //   stream: false,
    //   bufferutil: false,
    //   "utf-8-validate": false,
    // },
  },
};
